// IplUtil.h: IplUtil NX̃C^[tFCX
// IPL֌W̃[eBeBTu[`W
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_IPLUTIL_H__1411E1AE_DF71_4D7F_A2D0_8F622263A160__INCLUDED_)
#define AFX_IPLUTIL_H__1411E1AE_DF71_4D7F_A2D0_8F622263A160__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
#include "ipl.h" // Intel Performance Library 2.5g߁B
#include "OutMsg.h"	// ClassView ɂĒǉ܂B

class IplUtil  
{
public:
	void makeSaveBorder(IplImage* img);
	void useSaveBorder(IplImage* imgflame, IplImage* img);
	void ChangeBlack(IplImage*img);
	int AlphaFill(IplImage *img);
	void FillOnlyColor(IplImage* img, int r, int g, int b);
	void BorderAlpha(IplImage* img, int len);
	int Pint(int len, IplImage* src, IplImage* dst, int type);
	void ClearBlack(IplImage* img);
	void Clear(IplImage* img);
	void ScrollCut2(IplImage *src, IplImage *dst, double mx, double my, BOOL tile);
	void setOutMsg(COutMsg* p_msg);
	void iplResizeAll(IplImage* srcImage, IplImage* dstImage, int interpolate);
	int iplWriteTga(IplImage *img, CString filename, int compress); //Targa32bito
	int iplWriteBmp(IplImage *img, CString filename); // BMP32bito
	int iplWriteBmp2(IplImage *img, CString filename, CString filename2); //F(24bit)ƃ(8bit)BMPt@C
	void TilingFill(IplImage* img, int width, int height);
	void BlockCopy(IplImage* src, IplImage* dst, int sx, int sy, int dx, int dy, int width, int heiht);
	IplImage* ScrollZoom(IplImage* img, int sx, int sy, double x, double y, double zoom, BOOL tile, double scalex, double scaley);
	void Overlap(IplImage* src1, IplImage* src2, IplImage* dst, int mode);
	void FillAlpha(IplImage *img, int value);
	void MulAlpha(IplImage *img, float value);
	void iplAlphaConvertToDIB(IplImage *img, BITMAPINFOHEADER *dib, unsigned char* dibtop, int dither, int paletteConversion);
	IplImage* AllocIpl(CSize size,int p_depth);
	IplImage* AllocIpl(int p_width, int p_height,int p_depth);
	IplImage* AllocIplGray(int p_width, int p_height,int p_depth);
	IplImage* AllocIplYUV(CSize size,int p_depth);
	IplImage* AllocIplYUV(int p_width, int p_height,int p_depth);
	int  iplMovOvw8( IplImage *img1, IplImage *imgwork,int axl, int ayl, int msk1);
	int  iplMovOvw8T( IplImage *img1, IplImage *imgwork,int axl, int ayl, int msk1);
	int Border(IplImage *img, int len);

	IplUtil(COutMsg* p_msg);
	IplUtil();
	virtual ~IplUtil();

private:
	int m_CPU;
	int CPU(); // CPUʔ
	void OutMsg(char *msg);
	COutMsg* m_msg; // _CAO܂̓t@CɃbZ[Wo
	int Border8(IplImage *img, int len);
	int Border16(IplImage *img, int len);
	void div(IplImage *srcA, IplImage* srcB, IplImage *dst);
	void idiv(IplImage *srcA, IplImage* srcB, IplImage *dst);
	void lum(IplImage* srcA, IplImage* srcB, IplImage* dst);
	void lite(IplImage* srcA, IplImage* srcB, IplImage* dst);
	void dark(IplImage* srcA, IplImage* srcB, IplImage* dst);
	void ScrollCut(IplImage *src, IplImage *dst, double mx, double my, BOOL tile);
	void BorderAlpha8(IplImage* img, int len);
	void BorderAlpha16(IplImage* img, int len);
	void ChangeBlack8(IplImage*img);
	void ChangeBlack16(IplImage*img);
	int AlphaFill8(IplImage *img);
	int AlphaFill16(IplImage *img);
	unsigned int searchColorL8(IplImage *img, int x, int y, unsigned char *pixel);
	unsigned int searchColorR8(IplImage *img, int x, int y, unsigned char *pixel);
	unsigned int searchColorU8(IplImage *img, int x, int y, unsigned char *pixel);
	unsigned int searchColorD8(IplImage *img, int x, int y, unsigned char *pixel);
	void makeSaveBorder8(IplImage* img);
	void makeSaveBorder16(IplImage* img);
	void useSaveBorder8(IplImage* imgflame, IplImage* img);
	void useSaveBorder16(IplImage* imgflame, IplImage* img);

	//Targa֘A
	int RLEncodeRow( char *p,char *q, int n, int bpp);
	int CountDiffPixels( char *p, int bpp, int pixCnt);
	int CountSamePixels( char *p, int bpp, int pixCnt);
	unsigned long GetPixel( char *pp, int bpp);

};

#endif // !defined(AFX_IPLUTIL_H__1411E1AE_DF71_4D7F_A2D0_8F622263A160__INCLUDED_)
