// OfsetWindow.h: COfsetWindow NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OFSETWINDOW_H__8DD1AAD0_3607_4C4A_8891_6FD17A269F87__INCLUDED_)
#define AFX_OFSETWINDOW_H__8DD1AAD0_3607_4C4A_8891_6FD17A269F87__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class COfsetWindow  
{
public:
	RGBQUAD* GetRGBtop();
	RECT GetRect();
	int PutAlphaValue(int px, int py, char p_val);
	char GetAlphaValue(int px, int py);
	int PutPixel(int px, int py, RGBQUAD col);
	COfsetWindow(const void *top, RECT rect);
	char * GetChar(int px, int py);
	RGBQUAD* GetPixel(int px, int py, RGBQUAD* p_blank=NULL);
	COfsetWindow();
	virtual ~COfsetWindow();

private:
	RGBQUAD* m_rgbtop;
	char* m_chartop;
	RECT m_rect;
	int m_width;
	int m_height;

	//͈͊O̎ɕԂf[^
	RGBQUAD blank_rgb;
	char blank_char;
};

#endif // !defined(AFX_OFSETWINDOW_H__8DD1AAD0_3607_4C4A_8891_6FD17A269F87__INCLUDED_)
