// peg.h: Cpeg NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PEG_H__B64D898A_72E4_4058_A00A_BFA67A5C3084__INCLUDED_)
#define AFX_PEG_H__B64D898A_72E4_4058_A00A_BFA67A5C3084__INCLUDED_

//#include "PegAction.h"	// ClassView ɂĒǉ܂B
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

// Peg̍[hꗗ
// http://ofo.jp/osakana/cgtips/blendmode.phtml ɉ
// Pa= Pb= Pn=
#define STR_MODE_NORM "norm"  // (ʏj 
#define STR_MODE_NORMAL "normal"  // (ʏj 

#define STR_MODE_DARK "dark"  //iÂj rF
/*
 Pa >= Pb ̎
 Pn = Pb
 Pa < Pb ̎
 Pn = Pa
*/

#define STR_MODE_LITE "lite"  //i邭j r:
/*
Pa >= Pb ̎
Pn = Pa
Pa < Pb ̎
Pn = Pb
*/

#define STR_MODE_HUE  "hue"  //iFj 

#define STR_MODE_SAT  "sat"  //iʓxj 

#define STR_MODE_COLR "colr"  //iFƍʓxj 

#define STR_MODE_LUM  "lum"  //iPxj 

#define STR_MODE_MUL  "mul"  //iZj
/* Pn = Pa * Pb / 255@PnA
 PaAPb 0`1͈̔͂Ƃꍇ́APn = Pa * Pb 
*/

#define STR_MODE_SCRN "scrn"  //iXN[j
/* Pn = Pa + Pb - Pa * Pb / 255@
 PnAPaAPb 0`1͈̔͂Ƃꍇ́A
 Pn = 1 - ( ( 1 - Pa ) * ( 1 - Pb ) )ƂȂ܂B
 2iIɂ̓rbg]Ă킹ărbg]B
*/

#define STR_MODE_DISS "diss"  //ifBUj 

#define STR_MODE_OVER "over" //iI[o[Cj
/* Pa > 128 ̏ꍇ
 Pn = 2 * (Pa + Pb - Pa * Pb / 255) - 255
 Pa < 128 ̏ꍇ
 Pn = Pa * Pb * 2 / 255
 Pa = 128 ̏ꍇ Pn = Pa

 PnAPaAPb 0`1͈̔͂ƂꍇA
 Pa = 0.5̂Ƃ
 Pn = Pa
 Pa > 0.5̂Ƃ
 Pn = 1 - 2 * ( 1 - Pa ) * ( 1 - Pb )
 Pa < 0.5̂Ƃ
 Pn = Pa * Pb * 2
*/

#define STR_MODE_HLIT "hlit" //in[hCgj 
/*
 Pb = 128̎ 
 Pn = Pa
 Pb < 128̎
 Pn = Pa * Pb * 2 / 255
 Pb > 128̎
 Pn = 2 * ( Pa + Pb - Pa * Pb / 255 ) - 255

 PnAPaAPb 0`1͈̔͂ƂꍇA
 Pb = 0.5̎
 Pn = Pa
 Pb < 0.5̎
 Pn = Pa * Pb * 2
 Pb > 0.5̎
 Pn = 1 - 2 * ( 1 - Pa ) * ( 1 - Pb )
*/

#define STR_MODE_SLIT "slit" //i\tgCgj 
/*
 Pb = 128̎
 Pn = Pa
 Pb < 128̎
 Pn = ( Pa / 255 ) ^ ( ( 255 - Pb ) / 128 )
 Pb > 128̎
 Pn = ( Pa / 255 ) ^ ( 128 / Pb )

 PnAPaAPb 0`1͈̔͂ƂꍇA
 Pb = 0.5̎
 Pn = Pa
 Pb < 0.5̎ 
 Pn = Pa ^ ( (1 - Pb) / 0.5 )
 Pb > 0.5̎
 Pn = Pa ^ ( 0.5 / Pb )
*/

#define STR_MODE_DIFF "diff" //i̐Βlj 
/*
Pn = | Pa - Pb |
*/

#define STR_MODE_DIV  "div" //iĂ݃J[j 
/*
Pn = 255 - (( 255 - Pa ) * 255 / Pb ))
APb = 0 ̏ꍇy Pn < 0 ̏ꍇAPn = 0
PnAPaAPb 0`1͈̔͂ƂꍇA
Pn = 1 - ( 1 - Pa ) / Pb
*/

#define STR_MODE_IDIV "idiv" //iĂ 
/*
Pn = Pa * 255 / ( 255 - Pb )
APb = 255 ̏ꍇy Pn > 255 ̏ꍇAPn = 255Ƃ
PnAPaAPb 0`1͈̔͂ƂꍇA
Pn = Pa / ( 1 - Pb )
*/

#define STR_MODE_EXCU "excu" // O
/*
Pn = Pa + Pb -2 * Pa * Pb / 255

PnAPaAPb 0`1͈̔͂Ƃꍇ́A
Pn = ( 1 - Pb ) * Pa + ( 1 - Pa ) * Pb
*/

#define STR_MODE_ADD "add" // Z
#define STR_MODE_AND "and" // AND
#define STR_MODE_OR "or" // OR
#define STR_MODE_XOR "xor" // XOR
#define STR_MODE_NOT "not" // NOT
#define STR_MODE_IMUL "imul" // ]Z

class Cpeg  
{
public:
	CString getModeStr();
	int setMode(CString str);
	// dˍ킹[h̃^Cv
	enum type {
			MODE_NORM=0, 
			MODE_DARK=1,
			MODE_LITE=2,
			MODE_HUE =3, 
			MODE_SAT =4, 
			MODE_COLR=5, 
			MODE_LUM =6, 
			MODE_MUL =7,
			MODE_SCRN=8,
			MODE_DISS=9,
			MODE_OVER=10,
			MODE_HLIT=11, 
			MODE_SLIT=12, 
			MODE_DIFF=13, 
			MODE_DIV =14, 
			MODE_IDIV=15, 
			MODE_EXCU=16,
			MODE_ADD =17,
			MODE_OR  =18,
			MODE_XOR =19,
			MODE_AND =20,
			MODE_NOT =21,
			MODE_IMUL=22
	};
	int order; //oꏇ
	CString name; // ̃yO̖O
	CString refer; // QƐyO̖O
	CStringArray layerOrder; //C̖O珇Ɋi[B
	CMapStringToOb layerArray; //CɊeR}ł̔ԍێBCLayeȑW܂
	CObArray actArray; // eR}ł̃yÖʒuێBCPecAction̏W܂
	int mode; // dˍ킹[h
	Cpeg();
	Cpeg(CString name);
	virtual ~Cpeg();

};

#endif // !defined(AFX_PEG_H__B64D898A_72E4_4058_A00A_BFA67A5C3084__INCLUDED_)
