// CellShade.h : CELLSHADE AvP[ṼC wb_[ t@CłB
//

#if !defined(AFX_CELLSHADE_H__B069B63A_B603_408B_9648_8CF216EB1715__INCLUDED_)
#define AFX_CELLSHADE_H__B069B63A_B603_408B_9648_8CF216EB1715__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// C V{

#include "colorTable.h"
#include "OfsetWindow.h"
#include "iplUtil.h"

#include < vector >
//#include "tlpsd.h"
#include "tlpsdex.h"
struct LAYER_IMAGE_ARRAY
{
    TLPSD_IMAGE_INFO   info;
	std::vector < RGBQUAD > image;
};

/////////////////////////////////////////////////////////////////////////////
// CCellShadeApp:
// ̃NX̓̒`ɊւĂ CellShade.cpp t@CQƂĂB
//

class CCellShadeApp : public CWinApp
{
public:
	CCellShadeApp();

	HINSTANCE m_hPsd;
	int InitialLoadDll();
	void FreeDll();

	TLPSD_GETVERSION		TlPsd_GetVersion;
	TLDSD_UNDERSCAN			TlPsd_UnderScan;
	TLDSD_MINIMIZE			TlPsd_Minimize;

	TLDSDLOAD_OPEN          TlPsdLoad_Open;
	TLDSDLOAD_CLOSE         TlPsdLoad_Close;
	TLDSDLOAD_GETLAYERCOUNT TlPsdLoad_GetLayerCount;
	TLDSDLOAD_GETIMAGEINFO  TlPsdLoad_GetImageInfo;
	TLDSDLOAD_GETIMAGE      TlPsdLoad_GetImage;

	TLDSDSAVE_OPEN          TlPsdSave_Open;
	TLDSDSAVE_CLOSE         TlPsdSave_Close;
	TLDSDSAVE_SETIMAGE      TlPsdSave_SetImage;
	TLDSDSAVE_SETLAYER      TlPsdSave_SetLayer;

	// ǂPSD̃f[^
	std::vector < RGBQUAD > g_merge_image;
	TLPSD_IMAGE_INFO   g_marge_info;
	std::vector < LAYER_IMAGE_ARRAY > g_layer;

	// oPSDpC[
	std::vector < LAYER_IMAGE_ARRAY > out_layer;

	int LoadAndSaveImage(LPCSTR lpszFileName, LPCSTR lpszPath,CcolorTable *pMc);

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CCellShadeApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Cve[V

	//{{AFX_MSG(CCellShadeApp)
		//  - ClassWizard ͂̈ʒuɃo֐ǉ܂͍폜܂B
		//        ̈ʒuɐR[hҏWȂłB
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	float gf(float x, float k);
	bool GetMargedImage(std::vector < RGBQUAD >& image, TLPSD_IMAGE_INFO& info);
	bool GetILayerImage(int index, LAYER_IMAGE_ARRAY& layer, RECT rcFrame);
	int MakeLayer(const void* lpData, const TLPSD_IMAGE_INFO info, LAYER_IMAGE_ARRAY& out_layer);
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_CELLSHADE_H__B069B63A_B603_408B_9648_8CF216EB1715__INCLUDED_)
