// colorTable.cpp: CcolorTable NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CellShade.h"
#include "colorTable.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CcolorTable::CcolorTable(COutMsg *msg)
{
	outmsg = msg;
	coltbl = new CObArray();
}

CcolorTable::~CcolorTable()
{
	if(coltbl != NULL){
		int max = coltbl->GetSize();
		for(int i=0; i<max;i++){
			CcolorItem *tmpItem=(CcolorItem*)coltbl->GetAt(i);
			delete tmpItem;
		}

		coltbl->RemoveAll();
		delete coltbl;
	}
}

// ^OJnɌĂ΂B
HRESULT STDMETHODCALLTYPE CcolorTable::startElement( 
            /* [in] */ wchar_t __RPC_FAR *pwchNamespaceUri,
            /* [in] */ int cchNamespaceUri,
            /* [in] */ wchar_t __RPC_FAR *pwchLocalName,
            /* [in] */ int cchLocalName,
            /* [in] */ wchar_t __RPC_FAR *pwchRawName,
            /* [in] */ int cchRawName,
            /* [in] */ ISAXAttributes __RPC_FAR *pAttributes)
{
	HRESULT hr = S_OK;
	int l;

	//TRACE("^OJn");
	if( wcsnicmp(pwchLocalName,L"layer",5) == 0 ) {
		TRACE(" layer^OJn");
		curItem = new CcolorItem();

		char name[MAX_PATH];
		pAttributes->getLength(&l);
		for ( int i=0; i<l; i++ ) {
			wchar_t * ln, * vl; int lnl, vll;
			pAttributes->getLocalName(i,&ln,&lnl); 
			pAttributes->getValue(i,&vl,&vll);
			if( wcsnicmp(ln,L"name",4) == 0 ) { //name=""
				memset(name,0,MAX_PATH);
				//BSTRToAscii(vl, name, vll); vllɂ͕̂œ{ꂾƍhhȂR
				BSTRToAscii(vl, name, MAX_PATH);
				TRACE("BEF=%s\n",name);
				if( curItem->setName(name) < 0){
					hr = E_FAIL;
				}
			}else if( wcsnicmp(ln,L"mode",4) == 0 ) { //mode="normal"
				memset(name,0,MAX_PATH);
				BSTRToAscii(vl, name, vll);
				if( curItem->setMode(name) < 0){
					hr = E_FAIL;
				}
			}
		}
	}
	return hr;
}

// ^OIɌĂ΂
HRESULT STDMETHODCALLTYPE CcolorTable::endElement( 
            /* [in] */ wchar_t __RPC_FAR *pwchNamespaceUri,
            /* [in] */ int cchNamespaceUri,
            /* [in] */ wchar_t __RPC_FAR *pwchLocalName,
            /* [in] */ int cchLocalName,
            /* [in] */ wchar_t __RPC_FAR *pwchRawName,
            /* [in] */ int cchRawName)
{
	HRESULT hr = S_OK;
	if( wcsnicmp(pwchLocalName,L"layer",5) == 0 ) {
		TRACE("layer ^OI");
		if(curItem != NULL){
			coltbl->InsertAt(0,(CObject*)curItem);
		}else{
			AfxMessageBox("G[:coltbl is NULL");
			hr = E_FAIL;
		}
	}

	return hr;
}

// JnɌĂ΂
HRESULT STDMETHODCALLTYPE CcolorTable::startDocument()
{
	HRESULT hr = S_OK;
	return hr;
}

// IɌĂ΂
HRESULT STDMETHODCALLTYPE CcolorTable::endDocument( void)
{
	HRESULT hr = S_OK;
	return hr;
}

