// colorTable.h: CcolorTable NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COLORTABLE_H__D21D22AB_3B0B_4D15_B81E_6EED014AABC4__INCLUDED_)
#define AFX_COLORTABLE_H__D21D22AB_3B0B_4D15_B81E_6EED014AABC4__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "SAXContentHandlerImpl.h"
#include <afxcoll.h>
#include "colorItem.h"
#include "OutMsg.h"

class CcolorTable : public SAXContentHandlerImpl
{
public:
	CcolorItem* FindColorItem(RGBQUAD rgba);
	CcolorTable(COutMsg *);
	virtual ~CcolorTable();

	COutMsg *outmsg;
	CObArray *coltbl;
	CcolorItem *curItem; // ݏ̃ACeBŎQ

	virtual HRESULT STDMETHODCALLTYPE startElement( 
		/* [in] */ wchar_t __RPC_FAR *pwchNamespaceUri,
		/* [in] */ int cchNamespaceUri,
		/* [in] */ wchar_t __RPC_FAR *pwchLocalName,
		/* [in] */ int cchLocalName,
		/* [in] */ wchar_t __RPC_FAR *pwchRawName,
		/* [in] */ int cchRawName,
		/* [in] */ ISAXAttributes __RPC_FAR *pAttributes);
        
	virtual HRESULT STDMETHODCALLTYPE endElement( 
		/* [in] */ wchar_t __RPC_FAR *pwchNamespaceUri,
		/* [in] */ int cchNamespaceUri,
		/* [in] */ wchar_t __RPC_FAR *pwchLocalName,
		/* [in] */ int cchLocalName,
		/* [in] */ wchar_t __RPC_FAR *pwchRawName,
		/* [in] */ int cchRawName);
		
	virtual HRESULT STDMETHODCALLTYPE startDocument();
	virtual HRESULT STDMETHODCALLTYPE endDocument( void);

};

#endif // !defined(AFX_COLORTABLE_H__D21D22AB_3B0B_4D15_B81E_6EED014AABC4__INCLUDED_)
